#include <iostream>
#include <iomanip>
#include <vector> 
#include <set>
#include <algorithm>

using namespace std;

inline wostream& operator <<(wostream& out, const vector<wchar_t>& obj) {
   for (auto p: obj) out << p;
   return out;
}

int main(void) {
   locale loc;
   try {
      loc = std::locale("ru_RU.utf8");
   }
   catch (std::runtime_error&) {
      loc = std::locale (loc, "", std::locale::ctype);
   }
   locale::global(loc);
   wchar_t s[] = L"В этих грустных краях всё рассчитано на зиму: сны,\n"
                  "стены тюрем, пальто; туалеты невест - белизны\n"
                  "новогодней, напитки, секундные стрелки.\n"
                  "Воробьиные кофты и грязь по числу щелочей;\n"
                  "пуританские нравы. Бельё. И в руках скрипачей -\n"
                  "деревянные грелки.\n";
   // copy & find :
   vector<wchar_t> v1(wcslen(s));
   copy(s, s + v1.size(), v1.begin());
   int nb = 0;
   for (auto is = find(v1.begin(), v1.end(), L' '); is != v1.end();
             is = find(++is, v1.end(), L' ')) nb++;
   wcout << L"в фразе пробелов " << nb << endl;
   vector<wstring> vs = {};
   wchar_t delim[] = L"\n", *state, *token = wcstok(s, delim, &state); // strtok_r()       
   for (; token != NULL; token = wcstok(NULL, delim, &state)) 
      vs.push_back(wstring(token));
   wcout << L"в фразе строк " << vs.size() << L':'<< endl;
   for (auto x : vs) wcout << x << endl;;
   // min & max :
   auto mm = minmax_element(v1.begin(), v1.end());
   wcout << L"диапазон символов: '" << *mm.first << L"' ... '" << *mm.second << L"'" << endl;
   // fill & reverse & rotate & shuffle :
   vector<wchar_t> suv(vs[0].size());
   copy(vs[0].begin(), vs[0].end(), suv.begin());
   wcout << left << setw(14) <<  L"строка: " << suv << endl;
   reverse(suv.begin(), suv.end());
   wcout << left << setw(14) << L"реверс: " << suv << endl;
   rotate(suv.begin(), suv.begin() + suv.size() / 2, suv.end());
   wcout << left << setw(14) << L"ротация: " << suv << endl;
   random_shuffle(suv.begin(), suv.end());
   wcout << left << setw(14) << L"перетасовка: " << suv << endl;
   // set_intersection & set_difference 
   set<wchar_t> sus, pns;
   for (wchar_t s: vector<wchar_t>(vs[0].begin(), vs[0].end())) sus.insert(s);
   for (wchar_t s: vector<wchar_t>(vs[1].begin(), vs[1].end())) pns.insert(s);
   vector<wchar_t> outi(300), outd(300);
   auto ret = set_intersection(sus.begin(), sus.end(), pns.begin(), pns.end(), outi.begin());
   wcout << L"общих литер " << (ret - outi.begin()) << L" : " << outi << endl;
   ret = set_difference(sus.begin(), sus.end(), pns.begin(), pns.end(), outd.begin());
   wcout << L"уникальных литер " << (ret - outd.begin()) << L" : " << outd << endl;
}

