package main

import (
	"bufio"
	"fmt"
	"os"
	"regexp"
)

func main() {
	pattern := "."
	if len(os.Args) > 1 {
		pattern = os.Args[1]
	}
	re, err := regexp.Compile(pattern)
	if err != nil {
		fmt.Println(err)
		return
	}
	sc := bufio.NewScanner(os.Stdin)
	for sc.Scan() {
		buf := sc.Text()
		if 0 == len(buf) { // выход
			break
		}
		res := re.FindAllSubmatch([]byte(buf), -1)
		if nil == res {
			fmt.Println("no match found")
			fmt.Println("--------------------")
			continue
		}
		ind := re.FindAllSubmatchIndex([]byte(buf), -1)
		for i := 0; i < len(res); i++ {
			for j := 0; j < len(res[i]); j++ {
				fmt.Printf("%d/%d : %s\n",
					ind[i][2*j], ind[i][2*j+1],
					res[i][j])
			}
		}
		fmt.Println("--------------------")
	}
}
