#!/usr/bin/python3
import sys
import re 

if len( sys.argv ) > 1:
    pattern = sys.argv[ 1 ]
else:
    pattern = r'\d\d\d'    
try:
    rex = re.compile( pattern, flags = re.IGNORECASE )
except Exception as exc:
    print( "error: {}".format( exc ) )
    sys.exit( 1 )

while(True):
    buf = sys.stdin.readline()[ :-1 ]
    if 0 == len( buf ):             # завершение работы
        break
    match = rex.search( buf )
    if match:        
        for i in range( 0, len( match.groups() ) + 1 ):
            print("{}/{} : {}".format( 
                     match.span( i )[ 0 ], match.span( i )[ 1 ],
                     match.group( i ) ) )
    else:
        print( "no match found" )
    print( "--------------------" )

re.purge()
sys.exit( 0 )
