use std::env;
use std::io;
use regex::Regex;

fn main() {
   let arguments: Vec<String> = env::args().collect();
   let pattern = if arguments.len() > 1 {
      arguments[1].clone()
   } else {
      String::from(r"(\d{4})-(\d{2})-(\d{2})")
   };
   loop {
      let mut input = String::new();
      io::stdin().read_line(&mut input).expect("ошибка ввода");
      if 1 == input.len() { break }; // выход
      let buf = &input[0 .. input.len() - 1];
      let re = Regex::new(&pattern).expect("ошибка шаблона");
      if 0 == re.captures_iter(buf).count() {
         println!("no match found");
         println!("--------------------");
         continue;
      }
      for caps in re.captures_iter(buf) {
         for i in 0..caps.len() {
            let cap = caps.get(i).unwrap();
            println!("{}/{} : {}",
                     cap.start(), cap.end(), cap.as_str());
         }
      }
      println!("--------------------");
   }
}
